unit MyCOMEventsHookUnit;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  ComObj, ActiveX, CommonClient_TLB, StdVcl;

type
  TCOMMessageHookEvent = procedure(const Msg: OleVariant) of object;

type
  TMyCOMEventsHook = class(TAutoObject, IMyCOMEventsHook)
  private
    FOnHook: TCOMMessageHookEvent;
  protected
    procedure OnMessage(Msg: OleVariant); safecall;
  public
    property OnHook: TCOMMessageHookEvent read FOnHook write FOnHook;
  end;

implementation

uses ComServ;

procedure TMyCOMEventsHook.OnMessage(Msg: OleVariant);
begin
  if Assigned(FOnHook) then FOnHook(Msg);
end;

initialization
  TAutoObjectFactory.Create(ComServer, TMyCOMEventsHook, Class_MyCOMEventsHook,
    ciInternal, tmApartment);
end.
